/*
   Compare this with 1-thread-vs-function.c
*/

public class Thread_vs_function_1_ver1
{
   public static void main(String[] args)
   {
      final Runnable f1 = new Function1();
      final Runnable f2 = new Function2();

      f1.run();  // Call the run() method in f1.
      f2.run();  // Call the run() method in f2.

      System.out.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}


class Function1 implements Runnable
{
   @Override
   public void run()
   {
      try
      {
         System.out.print("hello ");
         Thread.sleep(1000);  // throws InterruptedException
         System.out.println("from thread " + Thread.currentThread().getId() + "!\n");
      }
      catch (InterruptedException e){e.getMessage();}
   }
}


class Function2 implements Runnable
{
   @Override
   public void run()
   {
      try
      {
         System.out.print("HELLO ");
         Thread.sleep(1000);  // throws InterruptedException
         System.out.println("FROM THREAD " + Thread.currentThread().getId() + "!\n");
      }
      catch (InterruptedException e){e.getMessage();}
   }
}
