/*
   Compare this with 2-thread-vs-function.c
*/

public class Thread_vs_function_2_ver1
{
   public static void main(String[] args)
   {
      final Runnable f1 = new Function1();
      final Runnable f2 = new Function2();

      final Thread t1 = new Thread( f1 );
      final Thread t2 = new Thread( f2 );

      t1.start();   // Create a thread-of-execution in t1's run() method.
      t2.start();   // Create a thread-of-execution in t2's run() method.
    //t2.start();   // Can we start another thread in t2?

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.err.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}


class Function1 implements Runnable
{
   @Override
   public void run()
   {
      try
      {
         System.out.print("hello ");
         Thread.sleep(1000);
         System.out.println("from thread " + Thread.currentThread().getId() + "!\n");
      }
      catch (InterruptedException e){e.getMessage();}
   }
}


class Function2 implements Runnable
{
   @Override
   public void run()
   {
      try
      {
         System.out.print("HELLO ");
         Thread.sleep(1000);
         System.out.println("FROM THREAD " + Thread.currentThread().getId() + "!\n");
      }
      catch (InterruptedException e){e.getMessage();}
   }
}
