/*
   Compare this with 2-thread-vs-function.c
*/

public class Thread_vs_function_2_ver2
{
   public static void main(String[] args)
   {
      final Thread t1 = new Thread1();
      final Thread t2 = new Thread2();

      t1.start();   // Create a thread-of-execution in t1's run() method.
      t2.start();   // Create a thread-of-execution in t2's run() method.
    //t2.start();   // Can we start another thread in t2?

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.out.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}


class Thread1 extends Thread
{
   @Override
   public void run()
   {
      try
      {
         System.out.print("hello ");
         Thread.sleep(1000);
         System.out.println("from thread " + this.getId() + "!\n");
      }
      catch (InterruptedException e){e.getMessage();}
   }
}


class Thread2 extends Thread
{
   @Override
   public void run()
   {
      try
      {
         System.out.print("HELLO ");
         Thread.sleep(1000);
         System.out.println("FROM THREAD " + this.getId() + "!\n");
      }
      catch (InterruptedException e){e.getMessage();}
   }
}
