/*
   Compare this with 2-thread-vs-function.c
*/

public class Thread_vs_function_2_ver3
{
   public static void main(String[] args)
   {
      // Use an anonymous inner class that implements Runnable.
      Thread t1 = new Thread(
         new Runnable(){
            public void run() // Implement the Runnable interface.
            {
               try
               {
                  System.out.print("hello ");
                  Thread.sleep(1000);
                  System.out.println("from thread " + Thread.currentThread().getId() + "!\n");
               }
               catch (InterruptedException e){e.getMessage();}
            }});

      // Use an anonymous inner class that implements Runnable.
      Thread t2 = new Thread(
         new Runnable(){
            public void run() // Implement the Runnable interface.
            {
               try
               {
                  System.out.print("HELLO ");
                  Thread.sleep(1000);
                  System.out.println("FROM THREAD " + Thread.currentThread().getId() + "!\n");
               }
               catch (InterruptedException e){e.getMessage();}
            }});

      t1.start();   // Create a thread-of-execution in t1's run() method.
      t2.start();   // Create a thread-of-execution in t2's run() method.

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.out.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}
