/*
   Compare this with 3-thread-vs-function.c
*/

public class Thread_vs_function_3_ver4
{
   public static void main(String[] args)
   {
      // Use an anonymous inner class that extends Thread.
      Thread t1 = new Thread(){
            @Override
            public void run() // override run() from Thread class
            {
               try
               {
                  System.out.print("hello ");
                  Thread.sleep(1000);
                  System.out.println("from thread " + this.getId() + "!\n");
               }
               catch(InterruptedException e){e.getMessage();}
            }};

      // Use an anonymous inner class that extends Thread.
      Thread t2 = new Thread(){
            @Override
            public void run() // override run() from Thread class
            {
               try
               {
                  System.out.print("HELLO ");
                  Thread.sleep(1000);
                  System.out.println("FROM THREAD " + this.getId() + "!\n");
               }
               catch(InterruptedException e){e.getMessage();}
            }};

      t1.start(); // Create a thread-of-execution in t1's run() method.
      t2.run();   // Call the run() method in t2.

      try
      {
         t1.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.out.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}
