/*
   Compare this with 4-thread-vs-function-w-args.c
*/

public class Thread_vs_function_4_with_args_ver0
{
   public static void main(String[] args)
   {
      final Runnable f1 = new Function1(101);
      final Runnable f2 = new Function2(202);

      final Thread t1 = new Thread( f1 );
      final Thread t2 = new Thread( f2 );

      t1.start();
      t2.start();

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.out.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}


class Function1 implements Runnable
{
   public int arg;

   Function1(int arg)
   {
      this.arg = arg;
   }

   @Override
   public void run()
   {
      try
      {
         System.out.print("hello ");
         Thread.sleep(1000);
         System.out.println("from thread " + this.getId() + " with argument " + arg + "!\n");
      }
      catch (InterruptedException e){e.getMessage();}
   }
}


class Function2 implements Runnable
{
   public int arg;

   Function2(int arg)
   {
      this.arg = arg;
   }

   @Override
   public void run()
   {
      try
      {
         System.out.print("HELLO ");
         Thread.sleep(1000);
         System.out.println("FROM THREAD " + this.getId() + " WITH ARGUMENT " + arg + "!\n");
      }
      catch (InterruptedException e){e.getMessage();}
   }
}
