/*
   Compare this with 4-thread-vs-function-w-args.c
*/

public class Thread_vs_function_4_with_args_ver2
{
   public static void main(String[] args)
   {
      final Thread1 t1 = new Thread1();
      final Thread1 t2 = new Thread1();
      t1.x = 10;  // Set each thread's "input" values.
      t1.y = 20;
      t2.x = 30;
      t2.y = 40;

      t1.start();
      t2.start();

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.out.println(t1.x); // Get each thread's "output" value.
      System.out.println(t2.x);

      System.out.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}


class Thread1 extends Thread
{
   public int x = 0;  // Create "input" parameters for a thread.
   public int y = 0;

   @Override
   public void run()
   {
      try
      {
         System.err.print("hello ");
         Thread.sleep(1000);
         System.out.println("x = " + x +", y = "+ y);
         System.out.println("from thread " + this.getId() + "!\n");
         x = x + y;  // Create an "ouput" value for a thread.
      }
      catch (InterruptedException e){e.getMessage();}
   }
}
