/*
   Compare this with 4-thread-vs-function-w-args.c
*/

public class Thread_vs_function_4_with_args_ver3
{
   public static int z1 = 0; // create an "ouput" parameter for each thread
   public static int z2 = 0;

   public static void main(String[] args)
   {
      // Use an anonymous inner class that implements Runnable.
      final int x1 = 10; // Create "input" values for the thread.
      final int y1 = 20;
      Thread t1 = new Thread(
         new Runnable(){
            public void run()
            {
               try
               {
                  System.err.print("hello ");
                  Thread.sleep(1000);
                  System.out.println("x1 = " + x1 +", y1 = "+ y1);
                  System.out.println("from thread " + Thread.currentThread().getId() + "!\n");
                  z1 = x1 + y1; // Create an "ouput" value for this thread.
               }
               catch (InterruptedException e){e.getMessage();}
            }});

      // Use an anonymous inner class that implements Runnable
      final int x2 = 30; // Create "input" values for the thread.
      final int y2 = 40;
      Thread t2 = new Thread(
         new Runnable(){
            public void run()
            {
               try
               {
                  System.err.print("HELLO ");
                  Thread.sleep(1000);
                  System.out.println("x2 = " + x2 +", y2 = "+ y2);
                  System.out.println("FROM THREAD " + Thread.currentThread().getId() + "!\n");
                  z2 = x2 + y2; // Create an "ouput" value for this thread.
               }
               catch (InterruptedException e){e.getMessage();}
            }});

      t1.start();
      t2.start();

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.out.println( z1 ); // Get each thread's "output" value.
      System.out.println( z2 );

      System.out.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}
