/*
   Compare this with 6-two-threads-in-one-function.c
*/

public class Thread_vs_function_6
{
   private static final int N = 2; // Number of threads (try changing this value).

   public static void main(String[] args)
   {
      final Runnable[] runnable = new Runnable[N];
      final Thread[]   thread   = new Thread[N];

      // Create multiple threads from a single thread function.
      for (char i = 0, c = 'a'; i < N; ++i, ++c)
      {
         runnable[i] = new Function(c);          // Create the i'th run() method.
           thread[i] = new Thread(runnable[i]);  // Create the i'th Thread object.
           thread[i].start(); // Create a thread-of-execution in i'th run() method.
      }

      try
      {
         for (int i = 0; i < N; ++i)
         {
            thread[i].join();
         }
      }
      catch (InterruptedException e){e.getMessage();}

      System.out.printf("All done (tid = %d).\n", + Thread.currentThread().getId());
      return;
   }
}


class Function implements Runnable
{
   private final char c; // Thread parameter.

   public Function(char c)
   {
      this.c = c;
   }

   /**
      This thread function can be used to create an
      arbitrary number of "identical" threads.
   */
   @Override
   public void run()
   {
      while(true) // Loop forever.
      {
         System.out.print(c);
      }
   }
}
