/*

*/

import java.util.concurrent.TimeUnit;

/**
   This program creates 100,000 "empty" threads.
   The goal is to see much time it takes the
   operating system to do the overhead of just
   creating and disposing of threads.

   You can also let each thread "live" for just
   one second. That makes this program use up a
   lot more operating system resources.
*/
public class Threads_10_CreateEmptyTreads_ver2
{
   public static void main(String[] args)
   {
      final long startTime = System.nanoTime();

      for (int i = 0; i < 100_000; ++i)
      {
         (new Thread(new Function())).start();
      }

      final long endTime = System.nanoTime();
      final long timeElapsed = endTime - startTime;
      System.out.println("Execution time in nanoseconds: " + timeElapsed);
      System.out.println("Execution time in milliseconds: " + timeElapsed / 1_000_000);
   }
}


class Function implements Runnable
{
   @Override
   public void run()
   {
      //try{TimeUnit.SECONDS.sleep(1);}catch(Exception e){};
      return;
   }
}
