/*
   Java's thread ids may not be what you think they are.
*/

public class Threads_11_experiment_1
{
   public static void main(String[] args)
   {
      final Thread1 t1 = new Thread1();
      final Thread2 t2 = new Thread2();
      final Thread3 t3 = new Thread3();
      t1.theOther = t2;
      t2.theOther = t3;

      t1.run();
      System.out.println();

      t1.start();
      try
      {
         t1.join();
      }
      catch (InterruptedException e){e.getMessage();}
      System.out.println();

      t2.start();
      try
      {
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}
      System.out.println();

      t3.start();
      try
      {
         t3.join();
      }
      catch (InterruptedException e){e.getMessage();}
      System.out.println();

      System.out.printf("All done (tid = %d).\n", Thread.currentThread().getId());
      return;
   }
}


class Thread1 extends Thread
{
   public Thread theOther;

   @Override
   public void run()
   {
      System.out.printf("I think I'm thread %d, or maybe I am thread %d?\n",
                         this.getId(), Thread.currentThread().getId());
      theOther.run();
   }
}


class Thread2 extends Thread
{
   public Thread theOther;

   @Override
   public void run()
   {
      System.out.printf("I think I'm thread %d, or maybe I am thread %d?\n",
                         this.getId(), Thread.currentThread().getId());
      theOther.run();
   }
}


class Thread3 extends Thread
{
   @Override
   public void run()
   {
      System.out.printf("I think I'm thread %d, or maybe I am thread %d?\n",
                         this.getId(), Thread.currentThread().getId());
   }
}

// https://docs.oracle.com/en/java/javase/21/docs/api/java.base/java/lang/Thread.html#getId()
// https://docs.oracle.com/en/java/javase/21/docs/api/java.base/java/lang/Thread.html#threadId()
// https://docs.oracle.com/en/java/javase/21/docs/api/java.base/java/lang/Thread.html#currentThread()
// https://docs.oracle.com/en/java/javase/21/docs/api/java.base/java/lang/Thread.html#start()
